
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Rhombicuboctahedron()
{
    FILE *fp;
    extern char *filename;
    extern char creatingObject;
    creatingObject = 0;

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 50 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "rhombicuboctahedron.geom" );
    fp = fopen( filename, "w" );

    fprintf( fp, "25\t26\t97\n" );

    /* Print the Coordinates of the points */
    fprintf( fp, "0.357407 0.357407 0.862856\n" );
    fprintf( fp, "-0.357407 0.357407 0.862856\n" );
    fprintf( fp, "-0.357407 0.862856 0.357407\n" );
    fprintf( fp, "0.357407 -0.357407 0.862856\n" );
    fprintf( fp, "0.862856 0.357407 0.357407\n" );
    fprintf( fp, "0.357407 0.862856 0.357407\n" );
    fprintf( fp, "-0.357407 0.357407 -0.862856\n" );
    fprintf( fp, "-0.862856 0.357407 0.357407\n" );
    fprintf( fp, "-0.357407 0.862856 -0.357407\n" );
    fprintf( fp, "-0.357407 -0.357407 -0.862856\n" );
    fprintf( fp, "-0.862856 0.357407 -0.357407\n" );
    fprintf( fp, "0.357407 0.862856 -0.357407\n" );
    fprintf( fp, "-0.357407 -0.357407 0.862856\n" );
    fprintf( fp, "-0.862856 -0.357407 -0.357407\n" );
    fprintf( fp, "-0.357407 -0.862856 0.357407\n" );
    fprintf( fp, "0.862856 0.357407 -0.357407\n" );
    fprintf( fp, "0.862856 0 -0.357407\n" );
    fprintf( fp, "-0.862856 -0.357407 0.357407\n" );
    fprintf( fp, "0.357407 -0.862856 0.357407\n" );
    fprintf( fp, "0.357407 -0.357407 -0.862856\n" );
    fprintf( fp, "0.862856 -0.357407 0.357407\n" );
    fprintf( fp, "0.357407 -0.862856 -0.357407\n" );
    fprintf( fp, "0.357407 0.357407 -0.862856\n" );
    fprintf( fp, "0.862856 -0.357407 -0.357407\n" );
    fprintf( fp, "-0.357407 -0.862856 -0.357407\n" );

    /* Print the Conectivity data of the points */
    fprintf( fp, "4 0 1 12 3\n" );
    fprintf( fp, "4 4 15 11 5\n" );
    fprintf( fp, "3 0 4 5\n" );
    fprintf( fp, "4 11 8 2 5\n" );
    fprintf( fp, "4 2 1 0 5\n" );
    fprintf( fp, "4 2 8 10 7\n" );
    fprintf( fp, "3 1 2 7\n" );
    fprintf( fp, "3 6 10 8\n" );
    fprintf( fp, "4 6 9 13 10\n" );
    fprintf( fp, "4 22 6 8 11\n" );
    fprintf( fp, "4 14 18 3 12\n" );
    fprintf( fp, "4 1 7 17 12\n" );
    fprintf( fp, "3 12 17 14\n" );
    fprintf( fp, "5 4 20 23 16 15\n" );
    fprintf( fp, "4 7 10 13 17\n" );
    fprintf( fp, "3 3 18 20\n" );
    fprintf( fp, "4 4 0 3 20\n" );
    fprintf( fp, "4 18 14 24 21\n" );
    fprintf( fp, "4 19 9 6 22\n" );
    fprintf( fp, "3 11 15 22\n" );
    fprintf( fp, "4 19 22 15 23\n" );
    fprintf( fp, "3 21 19 23\n" );
    fprintf( fp, "4 20 18 21 23\n" );
    fprintf( fp, "4 9 19 21 24\n" );
    fprintf( fp, "3 13 9 24\n" );
    fprintf( fp, "4 14 17 13 24\n" );

    fclose( fp );

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 50 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "rhombicuboctahedron.aoff" );
    fp = fopen( filename, "w" );

    fprintf( fp, "geometry\tindexed_poly\tfff\t\t%s\n", "rhombicuboctahedron.geom" );
    fprintf( fp, "connect_offset\tdefault\t\tf\t\t0\n" );

    fclose( fp );
}
